import { Transform } from "../index";
import TokenProcessor from "../TokenProcessor";
export default class RootTransformer {
    readonly tokens: TokenProcessor;
    private transformers;
    private nameManager;
    constructor(tokens: TokenProcessor, transforms: Array<Transform>);
    transform(): string;
    processBalancedCode(): void;
    processToken(): void;
    /**
     * Skip past a class with a name and return that name.
     */
    processNamedClass(): string;
    processClass(): void;
    /**
     * We want to just handle class fields in all contexts, since TypeScript supports them. Later,
     * when some JS implementations support class fields, this should be made optional.
     */
    processClassBody(hasSuperclass: boolean): void;
    processPossibleTypeAnnotation(): boolean;
}
